diff --git a/arch/arm/mach-msm/devices.c b/arch/arm/mach-msm/devices.c
index 2952678..69accc8 100644
--- a/arch/arm/mach-msm/devices.c
+++ b/arch/arm/mach-msm/devices.c
@@ -284,6 +284,10 @@ static struct platform_device msm_device_usb_mass_storage = {
 		},
 };
 #endif
+
+static void do_usb_send_connect_notify(struct work_struct *send_usb_wq);
+static struct work_struct usb_connect_notifier_wq;
+
 void __init msm_add_usb_devices(void (*phy_reset) (void), void (*phy_shutdown) (void))
 {
 	if (phy_reset)
@@ -293,9 +297,8 @@ void __init msm_add_usb_devices(void (*phy_reset) (void), void (*phy_shutdown) (
 		msm_hsusb_pdata.phy_shutdown = phy_shutdown;
 
 	platform_device_register(&msm_device_hsusb);
-#ifdef CONFIG_USB_FUNCTION_MASS_STORAGE
 	platform_device_register(&msm_device_usb_mass_storage);
-#endif
+	INIT_WORK(&usb_connect_notifier_wq, do_usb_send_connect_notify);
 }
 /*
 void __init msm_change_usb_id(__u16 vendor_id, __u16 product_id)
@@ -1198,3 +1201,51 @@ void board_get_mid_tag(char **ret_data)
 	*ret_data = mid_tag;
 }
 EXPORT_SYMBOL(board_get_mid_tag);
+
+static DEFINE_MUTEX(notify_sem);
+static DEFINE_MUTEX(vbus_notify_sem);
+static atomic_t atomic_usb_connected = ATOMIC_INIT(0);
+static struct work_struct usb_connect_notifier_wq;
+static void (*set_vbus_state)(int online);
+
+static void do_usb_send_connect_notify(struct work_struct *send_usb_wq)
+{
+	mutex_lock(&notify_sem);
+
+	htc_battery_usb_status_notifier_func(atomic_read(&atomic_usb_connected));
+
+	mutex_unlock(&notify_sem);
+}
+
+void msm_usb_set_connect_status(int connected)
+{
+	atomic_set(&atomic_usb_connected, connected);
+	schedule_work(&usb_connect_notifier_wq);
+}
+EXPORT_SYMBOL(msm_usb_set_connect_status);
+
+int msm_usb_get_connect_status()
+{
+	return atomic_read(&atomic_usb_connected);
+}
+EXPORT_SYMBOL(msm_usb_get_connect_status);
+
+void msm_hsusb_set_vbus_state(int online)
+{
+	void (*setit)(int online);
+
+	mutex_lock(&vbus_notify_sem);
+	setit= set_vbus_state;
+	mutex_unlock(&vbus_notify_sem);
+
+	if (setit)
+		(*setit)(online);
+}
+
+void msm_hsusb_set_vbus_state_notifier(void (*setit)(int online))
+{
+	mutex_lock(&vbus_notify_sem);
+	set_vbus_state = setit;
+	mutex_unlock(&vbus_notify_sem);
+}
+EXPORT_SYMBOL(msm_hsusb_set_vbus_state_notifier);
diff --git a/arch/arm/mach-msm/htc_battery.c b/arch/arm/mach-msm/htc_battery.c
index 6893ece..13f32c3 100644
--- a/arch/arm/mach-msm/htc_battery.c
+++ b/arch/arm/mach-msm/htc_battery.c
@@ -205,12 +205,8 @@ static struct power_supply htc_power_supplies[] = {
 	},
 };
 
-static void usb_status_notifier_func(int online);
+void htc_battery_usb_status_notifier_func(int online);
 static int g_usb_online;
-static struct t_usb_status_notifier usb_status_notifier = {
-	.name = "htc_battery",
-	.func = usb_status_notifier_func,
-};
 
 /* -------------------------------------------------------------------------- */
 /* For sleep charging screen. */
@@ -479,7 +475,7 @@ int htc_cable_status_update(int status)
 /* A9 reports USB charging when helf AC cable in and China AC charger. */
 /* Work arround: notify userspace AC charging first,
 and notify USB charging again when receiving usb connected notificaiton from usb driver. */
-static void usb_status_notifier_func(int online)
+void htc_battery_usb_status_notifier_func(int online)
 {
 	mutex_lock(&htc_batt_info.lock);
 	if (htc_batt_debug_mask & HTC_BATT_DEBUG_USB_NOTIFY)
@@ -1231,7 +1227,6 @@ static int __init htc_battery_init(void)
 	wake_lock_init(&vbus_wake_lock, WAKE_LOCK_SUSPEND, "vbus_present");
 	mutex_init(&htc_batt_info.lock);
 	mutex_init(&htc_batt_info.rpc_lock);
-	usb_register_notifier(&usb_status_notifier);
 	msm_rpc_create_server(&battery_server);
 	platform_driver_register(&htc_battery_driver);
 	batt_register_client(&batt_notify);
diff --git a/arch/arm/mach-msm/include/mach/board.h b/arch/arm/mach-msm/include/mach/board.h
index 2c8b1f0..5a72440 100644
--- a/arch/arm/mach-msm/include/mach/board.h
+++ b/arch/arm/mach-msm/include/mach/board.h
@@ -135,15 +135,6 @@ int __init msm_add_serial_devices(unsigned uart);
 
 #if defined(CONFIG_USB_FUNCTION_MSM_HSUSB) || defined(CONFIG_USB_MSM_72K)
 void msm_hsusb_set_vbus_state(int online);
-/* START: add USB connected notify function */
-struct t_usb_status_notifier{
-	struct list_head notifier_link;
-	const char *name;
-	void (*func)(int online);
-};
-	int usb_register_notifier(struct t_usb_status_notifier *);
-	static LIST_HEAD(g_lh_usb_notifier_list);
-/* END: add USB connected notify function */
 #else
 static inline void msm_hsusb_set_vbus_state(int online) {}
 #endif
@@ -169,4 +160,9 @@ char *board_serialno(void);
 extern int panel_type;
 extern unsigned engineer_id;
 
+extern void htc_battery_usb_status_notifier_func(int online);
+extern void msm_usb_set_connect_status(int connected);
+extern int msm_usb_get_connect_status(void);
+extern void msm_hsusb_set_vbus_state_notifier(void (*setit)(int online));
+
 #endif
diff --git a/arch/arm/mach-msm/include/mach/msm_hsusb.h b/arch/arm/mach-msm/include/mach/msm_hsusb.h
index da46bfd..3868107 100644
--- a/arch/arm/mach-msm/include/mach/msm_hsusb.h
+++ b/arch/arm/mach-msm/include/mach/msm_hsusb.h
@@ -21,7 +21,6 @@
 
 /* platform device data for msm_hsusb driver */
 
-#ifdef CONFIG_USB_FUNCTION
 /* matches a product ID to a list of enabled functions */
 struct msm_hsusb_product {
 	/* product ID for usb_device_descriptor.idProduct */
@@ -32,7 +31,6 @@ struct msm_hsusb_product {
 	*/
 	__u32 functions;
 };
-#endif
 
 struct msm_hsusb_platform_data {
 	/* hard reset the ULPI PHY */
@@ -42,7 +40,6 @@ struct msm_hsusb_platform_data {
 	/* val, reg pairs terminated by -1 */
 	int *phy_init_seq;
 
-#ifdef CONFIG_USB_FUNCTION
 	/* USB device descriptor fields */
 	__u16 vendor_id;
 
@@ -66,7 +63,6 @@ struct msm_hsusb_platform_data {
 	*/
 	int num_products;
 	struct msm_hsusb_product *products;
-#endif
 };
 
 #endif
diff --git a/arch/arm/mach-msm/smd.c b/arch/arm/mach-msm/smd.c
index a166382..ed7ed35 100644
--- a/arch/arm/mach-msm/smd.c
+++ b/arch/arm/mach-msm/smd.c
@@ -773,6 +773,7 @@ int smd_open(const char *name, smd_channel_t **_ch,
 
 	return 0;
 }
+EXPORT_SYMBOL(smd_open);
 
 int smd_close(smd_channel_t *ch)
 {
@@ -795,21 +796,25 @@ int smd_close(smd_channel_t *ch)
 
 	return 0;
 }
+EXPORT_SYMBOL(smd_close);
 
 int smd_read(smd_channel_t *ch, void *data, int len)
 {
 	return ch->read(ch, data, len);
 }
+EXPORT_SYMBOL(smd_read);
 
 int smd_write(smd_channel_t *ch, const void *data, int len)
 {
 	return ch->write(ch, data, len);
 }
+EXPORT_SYMBOL(smd_write);
 
 int smd_read_avail(smd_channel_t *ch)
 {
 	return ch->read_avail(ch);
 }
+EXPORT_SYMBOL(smd_read_avail);
 
 int smd_write_avail(smd_channel_t *ch)
 {
diff --git a/drivers/usb/Kconfig b/drivers/usb/Kconfig
index 029d956..3de3d52 100644
--- a/drivers/usb/Kconfig
+++ b/drivers/usb/Kconfig
@@ -55,6 +55,9 @@ config USB_ARCH_HAS_EHCI
 	default y if PPC_83xx
 	default y if SOC_AU1200
 	default y if ARCH_IXP4XX
+	default y if ARCH_MSM7XXX
+	default y if ARCH_MSM
+	default y if ARCH_MSM7X00A
 	default PCI
 
 # ARM SA1111 chips have a non-PCI based "OHCI-compatible" USB host interface.
diff --git a/drivers/usb/function/Kconfig b/drivers/usb/function/Kconfig
index e013a97..01299c2 100644
--- a/drivers/usb/function/Kconfig
+++ b/drivers/usb/function/Kconfig
@@ -1,21 +1,31 @@
-menu "USB Function Support"
-
-config USB_FUNCTION
-	boolean "Support for USB Function Drivers"
+menuconfig USB_FUNCTION
+	tristate "Support for USB Function Drivers"
 	help
 	   The USB Function framework is similar to the Gadget framework
 	   but a little simpler and a little more plugable.  It trades
 	   some flexibility in the framework for smaller and simpler
 	   function drivers that can be combined into a composite driver.
 
+if USB_FUNCTION
+
+config  USB_FUNCTION_SELECTED
+        boolean
+
 choice
 	prompt "USB Peripheral Controller"
 	depends on USB_FUNCTION
 	
 config USB_FUNCTION_MSM_HSUSB
 	boolean "MSM7K Highspeed USB Peripheral Controller"
+	select USB_FUNCTION_SELECTED
 	depends on ARCH_MSM7XXX
 
+config USB_MSM_HSUSB
+        tristate
+        depends on USB_FUNCTION_MSM_HSUSB
+        default USB_FUNCTION
+        select USB_FUNCTION_SELECTED
+
 endchoice
 
 config USB_FUNCTION_NULL
@@ -49,10 +59,6 @@ config USB_FUNCTION_DIAG
 config USB_FUNCTION_ETHER
 	boolean "USB Ethernet Function"
 	depends on USB_FUNCTION
-config USB_FUNCTION_RNDIS
-        boolean "USB RNDIS support"
-        depends on USB_FUNCTION_ETHER
-        default y
 
 config USB_FUNCTION_FSYNC
 	boolean "USB MSM7K FSYNC Function"
@@ -62,12 +68,8 @@ config USB_FUNCTION_SERIAL
 	boolean "USB SERIAL Function"
 	depends on USB_FUNCTION
 
-config USB_FUNCTION_PROJECTOR
-	boolean "USB PROJECTOR Function"
-	depends on USB_FUNCTION
-
 config USB_FUNCTION_MTP_TUNNEL
 	boolean "MTP Tunnel Transport Function"
 	depends on USB_FUNCTION
 
-endmenu
+endif # USB_FUNCTION
diff --git a/drivers/usb/function/Makefile b/drivers/usb/function/Makefile
index 27b8ab4..ad4fa0e 100644
--- a/drivers/usb/function/Makefile
+++ b/drivers/usb/function/Makefile
@@ -1,15 +1,37 @@
 
-obj-$(CONFIG_USB_FUNCTION_MSM_HSUSB)	+= msm_hsusb.o
-obj-$(CONFIG_USB_FUNCTION_NULL)		+= null.o
-obj-$(CONFIG_USB_FUNCTION_NULL)		+= zero.o
-obj-$(CONFIG_USB_FUNCTION_LOOPBACK)	+= loopback.o
-obj-$(CONFIG_USB_FUNCTION_ADB)		+= adb.o
-obj-$(CONFIG_USB_FUNCTION_UMS)		+= ums.o
-obj-$(CONFIG_USB_FUNCTION_MASS_STORAGE)		+= mass_storage.o
-obj-$(CONFIG_USB_FUNCTION_DIAG)		+= diag.o
-obj-$(CONFIG_USB_FUNCTION_ETHER)	+= ether.o
-obj-$(CONFIG_USB_FUNCTION_SERIAL)	+= fserial.o
-obj-$(CONFIG_USB_FUNCTION_FSYNC)	+= fsync.o
-obj-$(CONFIG_USB_FUNCTION_PROJECTOR)	+= projector.o
-obj-$(CONFIG_USB_FUNCTION_RNDIS)        += rndis.o
-obj-$(CONFIG_USB_FUNCTION_MTP_TUNNEL)   += mtp_tunnel.o
+ifeq ($(CONFIG_USB_FUNCTION_NULL),y)
+	USB_FUNCTION_DRIVERS		+= null.o
+endif
+ifeq ($(CONFIG_USB_FUNCTION_ZERO),y)
+	USB_FUNCTION_DRIVERS		+= zero.o
+endif
+ifeq ($(CONFIG_USB_FUNCTION_LOOPBACK),y)
+	USB_FUNCTION_DRIVERS		+= loopback.o
+endif
+ifeq ($(CONFIG_USB_FUNCTION_ADB),y)
+	USB_FUNCTION_DRIVERS		+= adb.o
+endif
+ifeq ($(CONFIG_USB_FUNCTION_UMS),y)
+	USB_FUNCTION_DRIVERS		+= ums.o
+endif
+ifeq ($(CONFIG_USB_FUNCTION_MASS_STORAGE),y)
+	USB_FUNCTION_DRIVERS		+= mass_storage.o
+endif
+ifeq ($(CONFIG_USB_FUNCTION_DIAG),y)
+	USB_FUNCTION_DRIVERS		+= diag.o
+endif
+ifeq ($(CONFIG_USB_FUNCTION_ETHER),y)
+	USB_FUNCTION_DRIVERS		+= ether.o rndis.o
+endif
+ifeq ($(CONFIG_USB_FUNCTION_SERIAL),y)
+	USB_FUNCTION_DRIVERS		+= fserial.o
+endif
+ifeq ($(CONFIG_USB_FUNCTION_FSYNC),y)
+	USB_FUNCTION_DRIVERS		+= fsync.o
+endif
+ifeq ($(CONFIG_USB_FUNCTION_MTP_TUNNEL),y)
+	USB_FUNCTION_DRIVERS		+= mtp_tunnel.o
+endif
+
+f_msm_hsusb-objs			:= msm_hsusb.o $(USB_FUNCTION_DRIVERS)
+obj-$(CONFIG_USB_MSM_HSUSB)		+= f_msm_hsusb.o
diff --git a/drivers/usb/function/adb.c b/drivers/usb/function/adb.c
index 7f1dce9..2333912 100644
--- a/drivers/usb/function/adb.c
+++ b/drivers/usb/function/adb.c
@@ -381,6 +381,13 @@ static void adb_unbind(void *_ctxt)
 
 	DBG("%s()\n", __func__);
 
+	if (ctxt->read_req) {
+		usb_ept_free_req(ctxt->out, ctxt->read_req);
+		ctxt->read_req = 0;
+	}
+	while ((req = req_get(ctxt, &ctxt->rx_done))) {
+		usb_ept_free_req(ctxt->out, req);
+	}
 	while ((req = req_get(ctxt, &ctxt->rx_idle))) {
 		usb_ept_free_req(ctxt->out, req);
 	}
@@ -393,9 +400,13 @@ static void adb_unbind(void *_ctxt)
 
 	/* readers may be blocked waiting for us to go online */
 	wake_up(&ctxt->read_wq);
+	wake_up(&ctxt->write_wq);
+
+	misc_deregister(&adb_device);
+	misc_deregister(&adb_enable_device);
 }
 
-static void adb_bind(struct usb_endpoint **ept, void *_ctxt)
+static int adb_bind(struct usb_endpoint **ept, void *_ctxt)
 {
 	struct adb_context *ctxt = _ctxt;
 	struct usb_request *req;
@@ -408,7 +419,7 @@ static void adb_bind(struct usb_endpoint **ept, void *_ctxt)
 
 	for (n = 0; n < RX_REQ_MAX; n++) {
 		req = usb_ept_alloc_req(ctxt->out, 512);
-		if (req == 0) goto fail;
+		if (req == 0) goto out_alloc_fail;
 		req->context = ctxt;
 		req->complete = adb_complete_out;
 		req_put(ctxt, &ctxt->rx_idle, req);
@@ -416,22 +427,33 @@ static void adb_bind(struct usb_endpoint **ept, void *_ctxt)
 
 	for (n = 0; n < TX_REQ_MAX; n++) {
 		req = usb_ept_alloc_req(ctxt->in, 4096);
-		if (req == 0) goto fail;
+		if (req == 0) goto in_alloc_fail;
 		req->context = ctxt;
 		req->complete = adb_complete_in;
 		req_put(ctxt, &ctxt->tx_idle, req);
 	}
 
+	if (misc_register(&adb_device))
+		goto misc_device_fail_1;
+	if (misc_register(&adb_enable_device))
+		goto misc_device_fail_2;
+
 	DBG("%s: allocated %d rx and %d tx requests\n",
 	       __func__, RX_REQ_MAX, TX_REQ_MAX);
+	return 0;
 
-	misc_register(&adb_device);
-	misc_register(&adb_enable_device);
-	return;
-
-fail:
-	printk(KERN_ERR "%s() could not allocate requests\n", __func__);
-	adb_unbind(ctxt);
+misc_device_fail_2:
+	misc_deregister(&adb_device);
+misc_device_fail_1:
+in_alloc_fail:
+	while ((req = req_get(ctxt, &ctxt->tx_idle))) {
+		usb_ept_free_req(ctxt->in, req);
+	}
+out_alloc_fail:
+	while ((req = req_get(ctxt, &ctxt->rx_idle))) {
+		usb_ept_free_req(ctxt->out, req);
+	}
+	return -1;
 }
 
 static void adb_configure(int configured, void *_ctxt)
@@ -490,7 +512,7 @@ static struct usb_function usb_func_adb = {
 	.ifc_index = STRING_ADB,
 };
 
-static int __init adb_init(void)
+void adb_init(void)
 {
 	struct adb_context *ctxt = &_context;
 	DBG("adb_init()\n");
@@ -509,7 +531,5 @@ static int __init adb_init(void)
 	INIT_LIST_HEAD(&ctxt->rx_done);
 	INIT_LIST_HEAD(&ctxt->tx_idle);
 
-	return usb_function_register(&usb_func_adb);
+	usb_function_register(&usb_func_adb);
 }
-
-module_init(adb_init);
diff --git a/drivers/usb/function/diag.c b/drivers/usb/function/diag.c
index 6fd9716..0a2d9ea 100644
--- a/drivers/usb/function/diag.c
+++ b/drivers/usb/function/diag.c
@@ -46,8 +46,6 @@
 
 #define DIAG_FUNCTION_NAME "diag"
 
-int g_bUsbDiagMode = 0;
-
 struct diag_context
 {
 	int online;
@@ -107,6 +105,7 @@ struct diag_context
 };
 
 static struct diag_context _context;
+static int cleanup = 0;
 
 struct device diag_device;
 enum data_access {
@@ -381,18 +380,24 @@ done:
 
 }
 
+static int msm_diag_remove(struct platform_device *pdev)
+{
+	struct diag_context *ctxt = &_context;
+	smd_close(ctxt->ch);
+	return 0;
+}
+
 static int msm_diag_probe(struct platform_device *pdev)
 {
 	struct diag_context *ctxt = &_context;
-	int r;
 
 	ctxt->pdev = pdev;
-	r = smd_open("SMD_DIAG", &ctxt->ch, ctxt, smd_diag_notify);
-	return 0;
+	return smd_open("SMD_DIAG", &ctxt->ch, ctxt, smd_diag_notify);
 }
 
 static struct platform_driver msm_smd_ch1_driver = {
 	.probe = msm_diag_probe,
+	.remove = msm_diag_remove,
 	.driver = {
 		.name = DIAG_FUNCTION_NAME,
 		.owner = THIS_MODULE,
@@ -633,7 +638,7 @@ static int diag_open(struct inode *ip, struct file *fp)
 {
 	struct diag_context *ctxt = &_context;
 	struct usb_request *req;
-	
+
 	if (_lock(&ctxt->open_excl))
 		return -EBUSY;
 
@@ -642,6 +647,8 @@ static int diag_open(struct inode *ip, struct file *fp)
 	ctxt->error = 0;
 
 	req = usb_ept_alloc_req(ctxt->in, 8192);
+	if (req == NULL)
+		return -ENOMEM;
 
 	req->context = ctxt;
 	req->complete = diag_complete_in;
@@ -873,15 +880,20 @@ static void diag_unbind(void *_ctxt)
 	struct diag_context *ctxt = _ctxt;
 	struct usb_request *req;
 
-	printk(KERN_DEBUG "diag_unbind()\n");
-
-	misc_deregister(&diag_device_fops);
-	misc_deregister(&diag2arm9_device);
-
-	device_remove_file(&diag_device, &dev_attr_diag_xfer_count);
-	device_unregister(&diag_device);
-	smd_xfer_count_func(0,data_set_clear);
-
+	if (ctxt->read_req) {
+		usb_ept_free_req(ctxt->out, ctxt->read_req);
+		ctxt->read_req = 0;
+	}
+	if (ctxt->read_arm9_req) {
+		usb_ept_free_req(ctxt->out, ctxt->read_arm9_req);
+		ctxt->read_arm9_req = 0;
+	}
+	while ((req = get_req(ctxt, &ctxt->rx_done))) {
+		usb_ept_free_req(ctxt->out, req);
+	}
+	while ((req = get_req(ctxt, &ctxt->rx_arm9_done))) {
+		usb_ept_free_req(ctxt->out, req);
+	}
 	while ((req = get_req(ctxt, &ctxt->rx_idle))) {
 		usb_ept_free_req(ctxt->out, req);
 	}
@@ -898,9 +910,17 @@ static void diag_unbind(void *_ctxt)
 	/* readers may be blocked waiting for us to go online */
 	wake_up(&ctxt->read_wq);
 	wake_up(&ctxt->read_arm9_wq);
+	wake_up(&ctxt->write_wq);
+
+	misc_deregister(&diag_device_fops);
+	misc_deregister(&diag2arm9_device);
+
+	device_remove_file(&diag_device, &dev_attr_diag_xfer_count);
+	device_unregister(&diag_device);
+	smd_xfer_count_func(0,data_set_clear);
 }
 
-static void diag_bind(struct usb_endpoint **ept, void *_ctxt)
+static int diag_bind(struct usb_endpoint **ept, void *_ctxt)
 {
 	struct diag_context *ctxt = _ctxt;
 	struct usb_request *req;
@@ -914,7 +934,7 @@ static void diag_bind(struct usb_endpoint **ept, void *_ctxt)
 
 	for (n = 0; n < RX_REQ_MAX; n++) {
 		req = usb_ept_alloc_req(ctxt->out, 8192);
-		if (req == 0) goto fail;
+		if (req == 0) goto rx_idle_fail;
 		req->context = ctxt;
 		req->complete = diag_complete_out;
 		put_req(ctxt, &ctxt->rx_idle, req);
@@ -922,7 +942,7 @@ static void diag_bind(struct usb_endpoint **ept, void *_ctxt)
 
 	for (n = 0; n < TX_REQ_MAX; n++) {
 		req = usb_ept_alloc_req(ctxt->in, 8192);
-		if (req == 0) goto fail;
+		if (req == 0) goto tx_idle_fail;
 		req->context = ctxt;
 		req->complete = diag_complete_in;
 		put_req(ctxt, &ctxt->tx_idle, req);
@@ -930,36 +950,54 @@ static void diag_bind(struct usb_endpoint **ept, void *_ctxt)
 
 	for (n = 0; n < RX_REQ_MAX; n++) {
 		req = usb_ept_alloc_req(ctxt->out, 8192);
-		if (req == 0) goto fail;
+		if (req == 0) goto rx_arm9_idle_fail;
 		req->context = ctxt;
 		put_req(ctxt, &ctxt->rx_arm9_idle, req);
 	}
 
-	printk(KERN_DEBUG
-	       "diag_bind() allocated %d rx and %d tx requests\n",
-	       RX_REQ_MAX, TX_REQ_MAX);
-
-	misc_register(&diag_device_fops);
-	misc_register(&diag2arm9_device);
+	if (misc_register(&diag_device_fops))
+		goto misc_register_1_fail;
+	if (misc_register(&diag2arm9_device))
+		goto misc_register_2_fail;
 
 	diag_device.release = diag_dev_release;
 	diag_device.parent = &ctxt->pdev->dev;
 	strcpy(diag_device.bus_id, "interface");
 	if (device_register(&diag_device) != 0) {
 		DBG("diag failed to register device\n");
-		goto fail;
+		goto device_register_fail;
 	}
 	if (device_create_file(&diag_device, &dev_attr_diag_xfer_count) != 0) {
 		DBG("diag device_create_file failed");
-		device_unregister(&diag_device);
-		goto fail;
+		goto device_create_file_fail;
 	}
 	smd_xfer_count_func(0,data_set_clear);
-	return;
 
-fail:
-	printk(KERN_WARNING "diag_bind() could not allocate requests\n");
-	diag_unbind(ctxt);
+	printk(KERN_DEBUG
+	       "diag_bind() allocated %d rx and %d tx requests\n",
+	       RX_REQ_MAX, TX_REQ_MAX);
+	return 0;
+
+device_create_file_fail:
+	device_unregister(&diag_device);
+device_register_fail:
+	misc_deregister(&diag2arm9_device);
+misc_register_2_fail:
+	misc_deregister(&diag_device_fops);
+misc_register_1_fail:
+rx_arm9_idle_fail:
+	while ((req = get_req(ctxt, &ctxt->rx_arm9_idle))) {
+		usb_ept_free_req(ctxt->out, req);
+	}
+tx_idle_fail:
+	while ((req = get_req(ctxt, &ctxt->tx_idle))) {
+		usb_ept_free_req(ctxt->in, req);
+	}
+rx_idle_fail:
+	while ((req = get_req(ctxt, &ctxt->rx_idle))) {
+		usb_ept_free_req(ctxt->out, req);
+	}
+	return -1;
 }
 
 static void diag_configure(int configured, void *_ctxt)
@@ -1026,7 +1064,7 @@ static struct usb_function usb_func_diag = {
 
 };
 
-static int __init diag_init(void)
+void diag_init(void)
 {
 	int r, i;
 	struct diag_context *ctxt = &_context;
@@ -1061,27 +1099,29 @@ static int __init diag_init(void)
 		ctxt->id_table[i] = 0;
 
 	r = platform_driver_register(&msm_smd_ch1_driver);
-	if(r < 0)	{
-		printk(KERN_ERR "%s: Register driver fail\n", __func__);
-		return r;
-	}
+	if(r < 0)
+		goto platform_driver_register_fail;
 	r = platform_device_register(&diag_plat_device);
-	if (r < 0) {
-		printk(KERN_ERR "%s: Register device fail\n", __func__);
-		goto fail_register_device;
-	}
+	if (r < 0)
+		goto platform_device_register_fail;
 	r = usb_function_register(&usb_func_diag);
-	if (r < 0) {
-		printk(KERN_ERR "%s: Register function fail\n", __func__);
-		goto fail_function_device;
-	}
-	return r;
-fail_function_device:
+	if (r < 0)
+		goto usb_function_register_fail;
+	cleanup = 1;
+	return;
+
+usb_function_register_fail:
 	platform_device_unregister(&diag_plat_device);
-fail_register_device:
+platform_device_register_fail:
 	platform_driver_unregister(&msm_smd_ch1_driver);
-
-	return r;
+platform_driver_register_fail:
+	return;
 }
 
-module_init(diag_init);
+void diag_exit(void)
+{
+	if (cleanup) {
+		platform_driver_unregister(&msm_smd_ch1_driver);
+		platform_device_unregister(&diag_plat_device);
+	}
+}
diff --git a/drivers/usb/function/ether.c b/drivers/usb/function/ether.c
index 4e5c836..066a479 100755
--- a/drivers/usb/function/ether.c
+++ b/drivers/usb/function/ether.c
@@ -49,7 +49,9 @@
 
 static char		manufacturer [10] = "HTC";
 
+static struct net_device *the_dev;
 static int enabled = 0;
+static int cleanup = 0;
 
 #define STATUS_INTERVAL_MSEC 9 /* 2^8*125us = 32ms */
 
@@ -193,7 +195,7 @@ static void ether_in_complete(struct usb_endpoint *ept,
 			      struct usb_request *req);
 static void ether_out_complete(struct usb_endpoint *ept,
 			       struct usb_request *req);
-static void eth_bind(struct usb_endpoint **ept,
+static int eth_bind(struct usb_endpoint **ept,
 				void *_ctxt);
 static void eth_unbind(void *_ctxt);
 
@@ -324,27 +326,23 @@ static void eth_unbind(void *_ctxt)
 
 	while ((req = req_get(ctxt, &ctxt->tx_intr_reqs))) {
 		usb_ept_free_req(ctxt->intr_in, req);
-    }
+	}
 	while ((req = req_get(ctxt, &ctxt->rx_cmd_reqs))) {
 		usb_ept_free_req(ctxt->ep0out, req);
 	}
 	while ((req = req_get(ctxt, &ctxt->rx_reqs))) {
 		usb_ept_free_req(ctxt->out, req);
-    }
+	}
 	while ((req = req_get(ctxt, &ctxt->tx_reqs))) {
 		usb_ept_free_req(ctxt->in, req);
 	}
-	if (ctxt->registered == 1) {
-		device_remove_file(&ctxt->dev->dev, &dev_attr_enable);
-		ctxt->registered = 0;
-	}
+
+	device_remove_file(&ctxt->dev->dev, &dev_attr_enable);
 	rndis_deregister (ctxt->rndis_config);
-	//rndis_exit ();
-	//unregister_netdev (ctxt->dev);
-	//free_netdev(ctxt->dev);
+	rndis_exit();
 }
 
-static void eth_bind(struct usb_endpoint **ept, void *_ctxt)
+static int eth_bind(struct usb_endpoint **ept, void *_ctxt)
 {
 	struct ether_context *ctxt = _ctxt;
 	struct usb_request *req;
@@ -368,6 +366,7 @@ static void eth_bind(struct usb_endpoint **ept, void *_ctxt)
 	for (n = 0; n < MAX_INTR_TX; n++) {
 		req = usb_ept_alloc_req(ctxt->intr_in, 8);
 		if (!req)
+			goto tx_intr_reqs_fail;
 			break;
 		req->complete = rndis_control_ack_complete;
 		spin_lock_irqsave(&ctxt->lock, flags);
@@ -378,7 +377,7 @@ static void eth_bind(struct usb_endpoint **ept, void *_ctxt)
 	for (n = 0; n < MAX_EP0_RX; n++) {
 		req = usb_ept_alloc_req(ctxt->ep0out, 4096);
 		if (!req)
-			break;
+			goto rx_cmd_reqs_fail;
 		req->complete = receive_rndis_command;
 		spin_lock_irqsave(&ctxt->lock, flags);
 		list_add_tail(&req->list, &ctxt->rx_cmd_reqs);
@@ -388,7 +387,7 @@ static void eth_bind(struct usb_endpoint **ept, void *_ctxt)
 	for (n = 0; n < MAX_RX; n++) {
 		req = usb_ept_alloc_req(ctxt->out, 0);
 		if (!req)
-			break;
+			goto rx_reqs_fail;
 		req->complete = ether_out_complete;
 		spin_lock_irqsave(&ctxt->lock, flags);
 		list_add_tail(&req->list, &ctxt->rx_reqs);
@@ -397,7 +396,7 @@ static void eth_bind(struct usb_endpoint **ept, void *_ctxt)
 	for (n = 0; n < MAX_TX; n++) {
 		req = usb_ept_alloc_req(ctxt->in, 0);
 		if (!req)
-			break;
+			goto tx_reqs_fail;
 		req->complete = ether_in_complete;
 		spin_lock_irqsave(&ctxt->lock, flags);
 		list_add_tail(&req->list, &ctxt->tx_reqs);
@@ -406,13 +405,13 @@ static void eth_bind(struct usb_endpoint **ept, void *_ctxt)
 
 	ifc_desc= get_ifc_desc("ether");
 	if (!ifc_desc)
-		goto fail;
+		goto get_ifc_desc_fail;
 	control_intf.bInterfaceNumber = ifc_desc[0].bInterfaceNumber;
 	data_intf.bInterfaceNumber = ifc_desc[1].bInterfaceNumber;
 
 	ept_info = get_ept_info("ether");
 	if (!ept_info)
-		goto fail;
+		goto get_ept_info_fail;
 
 	status_desc.bEndpointAddress = ept_info[0].desc.bEndpointAddress;
 	sink_desc.bEndpointAddress = ept_info[1].desc.bEndpointAddress;
@@ -425,14 +424,14 @@ static void eth_bind(struct usb_endpoint **ept, void *_ctxt)
 	status = device_create_file(&ctxt->dev->dev, &dev_attr_enable);
 	if (status != 0) {
 		printk(KERN_ERR "ether device_create_file failed: %d\n", status);
-        goto fail;
+		goto device_create_file_fail;
 	}
 	ctxt->registered = 1;
 	ctxt->online = 0;
 	status = rndis_init();
 	if (status < 0) {
 		printk(KERN_ERR "can't init RNDIS, %d\n", status);
-		goto fail;
+		goto rndis_init_fail;
 	}
 
 	netif_stop_queue (ctxt->dev);
@@ -441,26 +440,48 @@ static void eth_bind(struct usb_endpoint **ept, void *_ctxt)
 	ctxt->rndis_config = rndis_register (rndis_control_ack);
 	if (ctxt->rndis_config < 0) {
 		printk(KERN_ERR "ether bind: rndis_register fial, %d\n", ctxt->rndis_config);
-		//unregister_netdev (ctxt->dev);
-		goto fail;
+		goto rndis_register_fail;
 	}
 
 	rndis_set_host_mac (ctxt->rndis_config, ctxt->host_mac);
 	if (rndis_set_param_dev (ctxt->rndis_config, ctxt->dev,
 					 &ctxt->stats, &ctxt->cdc_filter))
-		goto fail;
+		goto rndis_set_fail;
 	if (rndis_set_param_vendor(ctxt->rndis_config, vendorID,
 					manufacturer))
-		goto fail;
+		goto rndis_set_fail;
 	if (rndis_set_param_medium(ctxt->rndis_config,
 					NDIS_MEDIUM_802_3, 0))
-		goto fail;
-
-	return;
+		goto rndis_set_fail;
+	return 0;
 
-fail:
-	eth_unbind (ctxt);
-	return;
+rndis_set_fail:
+	rndis_deregister(ctxt->rndis_config);
+rndis_register_fail:
+	rndis_exit();
+rndis_init_fail:
+	device_remove_file(&ctxt->dev->dev, &dev_attr_enable);
+device_create_file_fail:
+get_ept_info_fail:
+get_ifc_desc_fail:
+tx_reqs_fail:
+	while ((req = req_get(ctxt, &ctxt->tx_reqs))) {
+		usb_ept_free_req(ctxt->in, req);
+	}
+rx_reqs_fail:
+	while ((req = req_get(ctxt, &ctxt->rx_reqs))) {
+		usb_ept_free_req(ctxt->out, req);
+	}
+rx_cmd_reqs_fail:
+	while ((req = req_get(ctxt, &ctxt->rx_cmd_reqs))) {
+		usb_ept_free_req(ctxt->ep0out, req);
+	}
+tx_intr_reqs_fail:
+	while ((req = req_get(ctxt, &ctxt->tx_intr_reqs))) {
+		usb_ept_free_req(ctxt->intr_in, req);
+	}
+	printk(KERN_ERR "ether_bind() failed\n");
+	return -1;
 }
 
 static void ether_in_complete(struct usb_endpoint *ept,
@@ -795,7 +816,7 @@ static struct net_device_stats *usb_ether_get_stats(struct net_device *dev)
 	return &ctxt->stats;
 }
 
-static void __init usb_ether_setup(struct net_device *dev)
+static void usb_ether_setup(struct net_device *dev)
 {
 	struct ether_context *ctxt = netdev_priv(dev);
 
@@ -818,35 +839,42 @@ static void __init usb_ether_setup(struct net_device *dev)
 	random_ether_addr(ctxt->host_mac);
 }
 
-static int __init ether_init(void)
+int ether_init(void)
 {
 	struct net_device *dev;
 	struct ether_context *ctxt;
-	int ret;
+	int ret = 0;
 
 	dev = alloc_netdev(sizeof(struct ether_context),
 			   "usb%d", usb_ether_setup);
 	if (!dev)
-		return -ENOMEM;
+		goto alloc_netdev_fail;
+	the_dev = dev;
 
 	ret = register_netdev(dev);
 	if (ret)
-		goto err_register_netdev;
+		goto register_netdev_fail;
 
 	ctxt = netdev_priv(dev);
 	usb_func_ether.context = ctxt;
 	ret = usb_function_register(&usb_func_ether);
 	if (ret < 0)
-		goto err_register_function;
-	return ret;
+		goto usb_function_register_fail;
+	cleanup = 1;
+	return 0;
 
-err_register_function:
+usb_function_register_fail:
 	unregister_netdev(dev);
-err_register_netdev:
+register_netdev_fail:
 	free_netdev(dev);
-
+alloc_netdev_fail:
 	return ret;
-
 }
 
-module_init(ether_init);
+void ether_exit(void)
+{
+	if (cleanup) {
+		unregister_netdev(the_dev);
+		free_netdev(the_dev);
+	}
+}
